//
//  HeadersH2TinyButtonModel.swift
//  MVMCoreUI
//
//  Created by Lekshmi S on 11/03/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//

import Foundation


public class HeadersH2TinyButtonModel: HeaderModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "headerH2BtnTny"
    public var headlineBody: HeadlineBodyModel
    public var button: ButtonModel
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    
    public init(headlineBody: HeadlineBodyModel, button: ButtonModel) {
        self.headlineBody = headlineBody
        self.button = button
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Methods
    //--------------------------------------------------
    
    public override func setDefaults() {
        if topPadding == nil {
            topPadding = Padding.Component.VerticalMarginSpacing
        }
        if bottomPadding == nil {
            bottomPadding = Padding.Component.VerticalMarginSpacing
        }
        super.setDefaults()
        button.style = .secondary
        button.size = .tiny
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case headlineBody
        case button
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        headlineBody = try typeContainer.decode(HeadlineBodyModel.self, forKey: .headlineBody)
        button = try typeContainer.decode(ButtonModel.self, forKey: .button)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(headlineBody, forKey: .headlineBody)
        try container.encode(button, forKey: .button)
    }
}
